﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;

namespace Erettsegi12_Utepites_Lambda
{
    class Jármű
    {
        public DateTime Belép { get; private set; }
        public DateTime Kilép { get; private set; }
        public char Felől { get; private set; }
        public double Sebesség {get; private set;}
        public Jármű(string[] m)
        {
            Belép = DateTime.Parse(string.Format("{0}:{1}:{2}", m[0], m[1], m[2]));
            Kilép = Belép.AddSeconds(int.Parse(m[3]));
            Felől = char.Parse(m[4]);
            Sebesség = 1000/double.Parse(m[3]);
        }
    
        public string FeléV {get { return Felől == 'A' ? "Felső" : "Alsó"; } }

        public string FelőlV {get { return Felől == 'A' ? "Alsó" : "Felső"; }}

    }
    class Ut
    {
        static void Main()
        {
            Console.WriteLine("1. Feladat: Adatok beolvasása");
            List<Jármű> járművek = new List<Jármű>();
            foreach (var i in File.ReadAllLines("forgalom.txt").Skip(1)) járművek.Add(new Jármű(i.Split()));

            Console.Write("2. Feladat: Kérem N értékét: ");
            Jármű kj = járművek[ int.Parse(Console.ReadLine())-1];
            Console.WriteLine("\tA gépjármű {0} város felé halad!", kj.FeléV);

            var sorrendFelső = járművek.Where(x => x.FeléV == "Felső").OrderByDescending(x => x.Belép).ToList();
            if (sorrendFelső.Count < 2) Console.WriteLine("Kevesebb, mint két autó haladt a Felső város felé!"); else
            Console.WriteLine("3. feladat: Utolsó két jármű különbsége Felső város irányába: {0} mp",(sorrendFelső.First().Belép-sorrendFelső[1].Belép).TotalSeconds);
            
            Console.WriteLine("4. Feladat: Statisztika:\n\t(Óra DbAlsóFelől DbFelsőFelől)");
            foreach (var i in járművek.GroupBy(g => g.Belép.Hour)) Console.WriteLine("\t{0} {1} {2}", i.Key, i.Count(x => x.Felől == 'A'), i.Count(x => x.Felől == 'F'));

            Console.WriteLine("5. Feladat: 10 leggyorsabb jármű:\n\t(Belép Felől Sebesség)");
            foreach (var i in járművek.OrderByDescending(x => x.Sebesség).Take(10)) Console.WriteLine("\t{0} {1} {2:F1} m/s", i.Belép.ToShortTimeString(), i.FelőlV, i.Sebesség);

            Console.WriteLine("6. Feladat: also.txt");
            DateTime aktKilép = járművek.First().Kilép;
            List<string> ki = new List<string>();
            foreach (var i in járművek.Where(x=>x.FeléV=="Alsó"))
            {
                if (aktKilép<i.Kilép) aktKilép=i.Kilép;
                ki.Add(string.Format("{0} {1} {2}", aktKilép.Hour, aktKilép.Minute, aktKilép.Second));
            }
            File.WriteAllLines("also.txt", ki);
            Console.ReadKey();
        }
    }
}

